"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// src/index.ts
var import_core = require("@babel/core");
var import_types = require("@babel/types");
var import_complugin = require("complugin");

// node_modules/lodash-es/_freeGlobal.js
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal_default = freeGlobal;

// node_modules/lodash-es/_root.js
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal_default || freeSelf || Function("return this")();
var root_default = root;

// node_modules/lodash-es/_Symbol.js
var Symbol = root_default.Symbol;
var Symbol_default = Symbol;

// node_modules/lodash-es/_getRawTag.js
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
var nativeObjectToString = objectProto.toString;
var symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var getRawTag_default = getRawTag;

// node_modules/lodash-es/_objectToString.js
var objectProto2 = Object.prototype;
var nativeObjectToString2 = objectProto2.toString;
function objectToString(value) {
  return nativeObjectToString2.call(value);
}
var objectToString_default = objectToString;

// node_modules/lodash-es/_baseGetTag.js
var nullTag = "[object Null]";
var undefinedTag = "[object Undefined]";
var symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var baseGetTag_default = baseGetTag;

// node_modules/lodash-es/isObjectLike.js
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default = isObjectLike;

// node_modules/lodash-es/isSymbol.js
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var isSymbol_default = isSymbol;

// node_modules/lodash-es/_trimmedEndIndex.js
var reWhitespace = /\s/;
function trimmedEndIndex(string) {
  var index = string.length;
  while (index-- && reWhitespace.test(string.charAt(index))) {
  }
  return index;
}
var trimmedEndIndex_default = trimmedEndIndex;

// node_modules/lodash-es/_baseTrim.js
var reTrimStart = /^\s+/;
function baseTrim(string) {
  return string ? string.slice(0, trimmedEndIndex_default(string) + 1).replace(reTrimStart, "") : string;
}
var baseTrim_default = baseTrim;

// node_modules/lodash-es/isObject.js
function isObject(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
var isObject_default = isObject;

// node_modules/lodash-es/toNumber.js
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol_default(value)) {
    return NAN;
  }
  if (isObject_default(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject_default(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim_default(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var toNumber_default = toNumber;

// node_modules/lodash-es/toFinite.js
var INFINITY = 1 / 0;
var MAX_INTEGER = 17976931348623157e292;
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber_default(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = value < 0 ? -1 : 1;
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}
var toFinite_default = toFinite;

// node_modules/lodash-es/toInteger.js
function toInteger(value) {
  var result = toFinite_default(value), remainder = result % 1;
  return result === result ? remainder ? result - remainder : result : 0;
}
var toInteger_default = toInteger;

// node_modules/lodash-es/before.js
var FUNC_ERROR_TEXT = "Expected a function";
function before(n, func) {
  var result;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  n = toInteger_default(n);
  return function() {
    if (--n > 0) {
      result = func.apply(this, arguments);
    }
    if (n <= 1) {
      func = void 0;
    }
    return result;
  };
}
var before_default = before;

// node_modules/lodash-es/once.js
function once(func) {
  return before_default(2, func);
}
var once_default = once;

// src/index.ts
var import_estree_to_babel = __toESM(require("estree-to-babel"));
var import_lru_cache = __toESM(require("lru-cache"));

// src/helpers.ts
var import_helper_module_imports = require("@babel/helper-module-imports");
var HELPERS = "\0compluginPluginBabelHelpers.js";
var helpers_default = function importHelperPlugin({ types: t }) {
  return {
    pre(file) {
      const cachedHelpers = /* @__PURE__ */ Object.create(null);
      file.set("helperGenerator", (name) => {
        if (!file.availableHelper(name)) {
          return null;
        }
        if (cachedHelpers[name]) {
          return t.cloneNode(cachedHelpers[name]);
        }
        return cachedHelpers[name] = (0, import_helper_module_imports.addNamed)(file.path, name, HELPERS);
      });
    }
  };
};

// src/utils.ts
var babelOptionsToJson = (options) => {
  const {
    auxiliaryCommentAfter,
    auxiliaryCommentBefore,
    babelrc,
    babelrcRoots,
    browserslistConfigFile,
    browserslistEnv,
    caller,
    comments,
    compact,
    configFile,
    env,
    envName,
    generatorOpts,
    minified,
    moduleId,
    moduleIds,
    moduleRoot,
    only,
    overrides,
    parserOpts,
    plugins,
    presets,
    retainLines
  } = options;
  return JSON.stringify([
    auxiliaryCommentAfter,
    auxiliaryCommentBefore,
    babelrc,
    babelrcRoots,
    browserslistConfigFile,
    browserslistEnv,
    caller,
    comments,
    compact,
    configFile,
    env,
    envName,
    generatorOpts,
    minified,
    moduleId,
    moduleIds,
    moduleRoot,
    only,
    overrides,
    parserOpts,
    plugins,
    presets,
    retainLines
  ]);
};

// src/index.ts
var babelAstCache = globalThis.__babelAstLRUCache;
if (!(babelAstCache instanceof import_lru_cache.default)) {
  ;
  globalThis.__babelAstLRUCache = babelAstCache = new import_lru_cache.default({
    max: 256,
    maxSize: 67108863,
    sizeCalculation: (_, key) => key.length * 8
  });
}
var initTransformCache = once_default(() => {
  let babelTransformCache = globalThis.__babelTransformLRUCache;
  if (!(babelTransformCache instanceof import_lru_cache.default)) {
    ;
    globalThis.__babelTransformLRUCache = babelTransformCache = new import_lru_cache.default({
      max: 1024,
      maxSize: 67108863,
      sizeCalculation: (value, key) => (value ? 2.5 : 1) * key.length
    });
  }
  return babelTransformCache;
});
var JS_TRANSFORM_CACHED_LIMIT = 512;
var JS_AST_CACHED_LIMIT = 256;
var compluginBabel = (0, import_complugin.createComplugin)({
  name: "babel",
  enforce: void 0,
  factory(options, meta) {
    let CWD = process.cwd();
    if (meta.framework === "esbuild") {
      CWD = meta.build.initialOptions.absWorkingDir ?? CWD;
    }
    const {
      include: _include = [/\.(tsx?|jsx?|mjs)$/i],
      exclude: _exclude,
      cwd,
      cache = true,
      ..._babelOptions
    } = options ?? {};
    const babelOptions = {
      ..._babelOptions,
      cloneInputAst: false,
      ast: true,
      code: true,
      sourceMaps: true,
      cwd: cwd ?? CWD
    };
    const transformCache = cache ? initTransformCache() : void 0;
    const getTransformOptionsAndWatchFiles = once_default(async () => {
      var _a, _b;
      const config = await (0, import_core.loadPartialConfigAsync)(babelOptions);
      const options2 = (config == null ? void 0 : config.options) ?? {};
      const watchFiles = /* @__PURE__ */ new Set();
      (options2.plugins ?? (options2.plugins = [])).push(helpers_default);
      if (config) {
        if (config.files) {
          ;
          (_b = (_a = config.files).forEach) == null ? void 0 : _b.call(_a, (configFile) => watchFiles.add(configFile));
        } else {
          if (typeof config.babelrc === "string") {
            watchFiles.add(config.babelrc);
          }
          if (config.config) {
            watchFiles.add(config.config);
          }
        }
      }
      return [options2, babelOptionsToJson(options2), watchFiles];
    });
    if (meta.framework === "esbuild") {
      meta.onResolveRegExp = new RegExp(`^${import_complugin.utils.escapeRegExp(HELPERS)}$`);
    }
    return {
      resolveId: (source) => source === HELPERS ? source : void 0,
      load: (id) => {
        if (id === HELPERS) {
          return (0, import_core.buildExternalHelpers)(null, "module");
        }
      },
      transformInclude: import_complugin.utils.createFilter(_include, _exclude),
      async transform(originalCode, id, ast) {
        const [transformOptions, transformOptionsStr, watchFiles] = await getTransformOptionsAndWatchFiles();
        const shouldCacheAst = originalCode.length >= JS_AST_CACHED_LIMIT;
        const optionsAndCode = !!transformCache && originalCode.length >= JS_TRANSFORM_CACHED_LIMIT && transformOptionsStr + originalCode;
        const finallyOptions = {
          ...transformOptions,
          filename: id
        };
        if (optionsAndCode) {
          const result2 = transformCache.get(optionsAndCode);
          if (result2) {
            const [code, map] = result2;
            return {
              code,
              map: this.sourceMap ? map : void 0
            };
          }
        } else {
          finallyOptions.sourceMaps = this.sourceMap;
          for (const watchFile of watchFiles) {
            this.addWatchFile(watchFile);
          }
        }
        let result;
        let babelAst = babelAstCache.get(originalCode);
        if (babelAst) {
          babelAst = (0, import_types.cloneNode)(babelAst, true);
        } else if (shouldCacheAst) {
          try {
            babelAstCache.set(originalCode, babelAst = (0, import_estree_to_babel.default)(ast));
          } catch {
          }
          if (!babelAst) {
            const parsedBabelAst = await (0, import_core.parseAsync)(originalCode, finallyOptions);
            if (parsedBabelAst) {
              babelAstCache.set(originalCode, babelAst = parsedBabelAst);
            }
          }
        }
        if (babelAst) {
          result = await (0, import_core.transformFromAstAsync)(babelAst, originalCode, finallyOptions);
        } else {
          result = await (0, import_core.transformAsync)(originalCode, finallyOptions);
        }
        if (result) {
          const { code, ast: ast2, map } = result;
          if (code != null) {
            if (shouldCacheAst && ast2) {
              babelAstCache.set(code, ast2);
            }
            if (optionsAndCode) {
              transformCache.set(optionsAndCode, [code, map ?? void 0]);
            }
            return { code, map: this.sourceMap ? map : void 0 };
          }
        }
      }
    };
  }
});
compluginBabel.default = compluginBabel;
module.exports = compluginBabel;
/**
 * @license
 * Lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="es" -o ./`
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
